#!/usr/bin/env python
# -*- coding: utf8 -*-

# WikikIRC est un petit script qui récupère le flux IRC du canal fr.wikipedia pour en faire des fichiers txt
# afin qu'ils soient lus et traduits en "MIDI" par Puredata via OSC.

# WikikIRC a été pondu par Olivier Baudu et Anthony Templier pour le Labomedia en septembre 2011.
# lamouraupeuple arobase gmail point com // http://lamomedia.net
# Publié sous license GPLv3 (http://www.gnu.org/licenses/gpl-3.0.html)

import simpleOSC
import irclib
import ircbot
import re

n = 0

simpleOSC.initOSCClient('127.0.0.1', 9000)

print ("Connexion en cours sur l'IRC...")

class BotModeration(ircbot.SingleServerIRCBot):

    def __init__(self):
        
        # paramètres de connexion IRC
        ircbot.SingleServerIRCBot.__init__(self, [("irc.wikimedia.org", 6667)], "Sonification_Wikipedia-LABOMEDIA", "Bot d'analyse syntaxique réalisé en Python avec ircbot")
        
        # filtre pour virer les codes couleurs et ne récupérer que le texte    
        self.filtre = re.compile( "\x03[0-9]{0,2}" )

    def on_welcome(self, serv, ev):
        
        # connexion au canal IRC
        serv.join("#fr.wikipedia")

    def on_pubmsg(self, serv, ev):
        
        global n

        message = ev.arguments()[0] # récupère les nouveaux messages
        sortie = self.filtre.sub('', message) # filtre les nouveaux messages
        n += 1
        
        # affiche le message en console
        print ('---------')
        print (n)
        print (sortie) 

        # écrit un fichier texte
        with open ("txt/"+str(n)+".txt", 'w') as new_file:
            new_file.write (sortie)
        
        # envoie un bang à Puredata
        simpleOSC.sendOSCMsg( '/test', [n] )

       
if __name__ == "__main__":
    BotModeration().start()

